/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreProcessvar.TCoreProcessvarPath;
import de.ship.db.tables.records.TCoreProcesstypeRecord;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreProcesstype extends TableImpl<TCoreProcesstypeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_processtype</code>
     */
    public static final TCoreProcesstype T_CORE_PROCESSTYPE = new TCoreProcesstype();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreProcesstypeRecord> getRecordType() {
        return TCoreProcesstypeRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_processtype.pk</code>.
     */
    public final TableField<TCoreProcesstypeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_processtype.name</code>.
     */
    public final TableField<TCoreProcesstypeRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_processtype.description</code>.
     */
    public final TableField<TCoreProcesstypeRecord, String> DESCRIPTION = createField(DSL.name("description"), SQLDataType.CLOB, this, "");

    private TCoreProcesstype(Name alias, Table<TCoreProcesstypeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreProcesstype(Name alias, Table<TCoreProcesstypeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_processtype</code> table
     * reference
     */
    public TCoreProcesstype(String alias) {
        this(DSL.name(alias), T_CORE_PROCESSTYPE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_processtype</code> table
     * reference
     */
    public TCoreProcesstype(Name alias) {
        this(alias, T_CORE_PROCESSTYPE);
    }

    /**
     * Create a <code>common_dd.t_core_processtype</code> table reference
     */
    public TCoreProcesstype() {
        this(DSL.name("t_core_processtype"), null);
    }

    public <O extends Record> TCoreProcesstype(Table<O> path, ForeignKey<O, TCoreProcesstypeRecord> childPath, InverseForeignKey<O, TCoreProcesstypeRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_PROCESSTYPE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreProcesstypePath extends TCoreProcesstype implements Path<TCoreProcesstypeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreProcesstypePath(Table<O> path, ForeignKey<O, TCoreProcesstypeRecord> childPath, InverseForeignKey<O, TCoreProcesstypeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreProcesstypePath(Name alias, Table<TCoreProcesstypeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreProcesstypePath as(String alias) {
            return new TCoreProcesstypePath(DSL.name(alias), this);
        }

        @Override
        public TCoreProcesstypePath as(Name alias) {
            return new TCoreProcesstypePath(alias, this);
        }

        @Override
        public TCoreProcesstypePath as(Table<?> alias) {
            return new TCoreProcesstypePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreProcesstypeRecord, Integer> getIdentity() {
        return (Identity<TCoreProcesstypeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreProcesstypeRecord> getPrimaryKey() {
        return Keys.T_CORE_PROCESSTYPE_PKEY;
    }

    @Override
    public List<UniqueKey<TCoreProcesstypeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.T_CORE_PROCESSTYPE_NAME_KEY);
    }

    private transient TCoreProcessvarPath _tCoreProcessvar;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_processvar</code> table
     */
    public TCoreProcessvarPath tCoreProcessvar() {
        if (_tCoreProcessvar == null)
            _tCoreProcessvar = new TCoreProcessvarPath(this, null, Keys.T_CORE_PROCESSVAR__T_CORE_PROCESSVAR_FK_PROCESSTYPE_FKEY.getInverseKey());

        return _tCoreProcessvar;
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        return tCoreProcessvar().tCoreProcessvarFkElementFkey();
    }

    @Override
    public TCoreProcesstype as(String alias) {
        return new TCoreProcesstype(DSL.name(alias), this);
    }

    @Override
    public TCoreProcesstype as(Name alias) {
        return new TCoreProcesstype(alias, this);
    }

    @Override
    public TCoreProcesstype as(Table<?> alias) {
        return new TCoreProcesstype(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreProcesstype rename(String name) {
        return new TCoreProcesstype(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreProcesstype rename(Name name) {
        return new TCoreProcesstype(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreProcesstype rename(Table<?> name) {
        return new TCoreProcesstype(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcesstype where(Condition condition) {
        return new TCoreProcesstype(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcesstype where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcesstype where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcesstype where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreProcesstype where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreProcesstype where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreProcesstype where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreProcesstype where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcesstype whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcesstype whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
